﻿package  {
	
	import flash.display.BitmapData
	import flash.display.Sprite
	import flash.display.Bitmap
	import flash.events.Event
	import flash.geom.Point
	
	/**
	* BitmapSpriteSource로 무비 클립을 찍은 후 BitmapSprite로 화면에 표시합니다.
	* 따라서 한 소스를 여러 BitmapSprite 객체에서 사용할 수 있습니다.
	* <br/> TODO <br/>
	* 모션 트위닝을 인식하지 못합니다. <br/>
	* 그 외의 문제를 제보해주세요.
	*/
	public class BitmapSprite extends Sprite {
		
		private var _src:BitmapSpriteSource
		private var _frame:int
		private var _bitmap:Bitmap
		
		public function BitmapSprite(src:BitmapSpriteSource,
								   					pixelSnapping:String="auto", smoothing:Boolean=true) {
			_src = src
			addChild(_bitmap = new Bitmap(null, pixelSnapping, smoothing))
			goto(1)
		}
		
		public function goto(frame:int):void {
			if(_frame == frame) return
			_frame = frame
			if(_src._captures[frame-1]){
				_bitmap.bitmapData = _src._captures[_frame-1]
				_bitmap.x = _src._offsets[_frame-1].x
				_bitmap.y = _src._offsets[_frame-1].y
				_bitmap.visible = true
			} else _bitmap.visible = false
		}
		
		/**
		* 생성자에서 인자로 받은 BitmapSpriteSource 객체입니다.
		*/
		public function get source():BitmapSpriteSource { return _src }
		public function set source(v:BitmapSpriteSource):void { _src = v }
		
		/**
		* 무비 클립과 동일합니다.
		*/
		public function get currentFrame():int { return _frame }
		/**
		* 무비 클립과 동일합니다.
		*/
		public function get totalFrames():int { return _src._captures.length }
		
		public function get currentBitmapData():BitmapData {
			return _src._captures[_frame-1]
		}
		public function get currentOffset():Point {
			return _src._offsets[_frame-1]
		}

	}
	
}
